      PROGRAM TEST3DS
C
C
C      Writen by Daniel Gaude-Fugarolas in February 2000
C
C     Asks for data and
C     launches D3SOLV
C
C
C      ...PARAMETERS...
      INTEGER		NMAX
      PARAMETER		(NMAX=100)
      INTEGER		NIN, NOUT
      PARAMETER 	(NIN=5,NOUT=6)
C
C      ...LOCAL SCALARS...
C
      INTEGER		I, N
C
C      ...Arrays...
C
      DOUBLE PRECISION DA(NMAX), UA(NMAX), LA(NMAX), B(NMAX), X(NMAX)
C
C      ...Program starts...
C      ...Reads entries...
C
      WRITE(NOUT,*) 'Dimension?'
      READ(NIN,*) N
      WRITE(NOUT,*) 'Main diagonal:', N, 'values'
      READ(NIN,*) (DA(I), I=1, N)
      WRITE(NOUT,*) 'Upper diagonal:', (N-1), ' values'
      READ(NIN,*) (UA(I), I=1, (N-1))
      WRITE(NOUT,*) 'Lower diagonal:', (N-1), 'values'
      READ(NIN,*) (LA(I), I=2, N)
      WRITE(NOUT,*) 'Independent terms:', N, 'values'
      READ(NIN,*) (B(I), I=1, N)
CC
C      ...Calls routine...
C
      CALL D3SOLV(N, DA, UA, LA, B, X)
C
C     ...and shows results...
C
      WRITE(NOUT,*) 'Solution vector'
      WRITE(NOUT,*)(X(I), I=1, N)
      WRITE(NOUT,*)'and new upper diagonal'
      WRITE(NOUT,*)(UA(I), I=1, (N-1))
C
C     ...End of program...
C 
      STOP
      END
C
C***********************************************************
C
      SUBROUTINE D3SOLV(N, DA, UA, LA, B, X)
C
C
C      Writen by Daniel Gaude-Fugarolas in February 2000
C
C     Solves tridiagonal simultaneous linear systems AX=B
C
C     Main diagonal...DA(1-n)  Upper/Lower...UA(1-(n-1))/LA(2-n)
C
C     In two steps, first prepares matrices, and then solves.
C
C     ...dummie arguments...
C
      INTEGER N
      DOUBLE PRECISION DA(N), UA(N), LA(N), B(N), X(N)
C
C     ...Local arguments...
C
      INTEGER I
      DOUBLE PRECISION TEMP
C
C     ...Routine starts...
C     ...First modifies matrices...
C
      TEMP = DA(1)
      B(1) = B(1) / TEMP
      UA(1) = UA(1) / TEMP
C
      DO 11, I=2, (N-1)
           TEMP = DA(I) - LA(I)*UA(I-1)
           B(I) = B(I) - B(I-1)*LA(I)
           UA(I) = UA(I) / TEMP
           B(I) = B(I) / TEMP
C
  11  CONTINUE
C
      TEMP = DA(N) - LA(N)*UA(N-1)
      B(N) = B(N) - B(N-1)*LA(N)
      B(N) = B(N) / TEMP
C
C
C     ...Now solves the system...
C          ...from N to 1...
C
      X(N) = B(N)
      DO 21, I=(N-1), 1, -1
           X(I) = B(I) - UA(I)*X(I+1)
  21  CONTINUE
C
C     ...End of the routine...
C
      RETURN
      END
C
